import { lazy } from 'react';
import { supportsWebKitPresentationMode } from '../utils';
import { canPlay, AUDIO_EXTENSIONS } from '../patterns';
export default [{
  key: 'youtube',
  name: 'YouTube',
  canPlay: canPlay.youtube,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerYouTube' */
    './YouTube');
  })
}, {
  key: 'soundcloud',
  name: 'SoundCloud',
  canPlay: canPlay.soundcloud,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerSoundCloud' */
    './SoundCloud');
  })
}, {
  key: 'vimeo',
  name: 'Vimeo',
  canPlay: canPlay.vimeo,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerVimeo' */
    './Vimeo');
  })
}, {
  key: 'facebook',
  name: 'Facebook',
  canPlay: canPlay.facebook,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerFacebook' */
    './Facebook');
  })
}, {
  key: 'streamable',
  name: 'Streamable',
  canPlay: canPlay.streamable,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerStreamable' */
    './Streamable');
  })
}, {
  key: 'wistia',
  name: 'Wistia',
  canPlay: canPlay.wistia,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerWistia' */
    './Wistia');
  })
}, {
  key: 'twitch',
  name: 'Twitch',
  canPlay: canPlay.twitch,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerTwitch' */
    './Twitch');
  })
}, {
  key: 'dailymotion',
  name: 'DailyMotion',
  canPlay: canPlay.dailymotion,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerDailyMotion' */
    './DailyMotion');
  })
}, {
  key: 'mixcloud',
  name: 'Mixcloud',
  canPlay: canPlay.mixcloud,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerMixcloud' */
    './Mixcloud');
  })
}, {
  key: 'vidyard',
  name: 'Vidyard',
  canPlay: canPlay.vidyard,
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerVidyard' */
    './Vidyard');
  })
}, {
  key: 'file',
  name: 'FilePlayer',
  canPlay: canPlay.file,
  canEnablePIP: function canEnablePIP(url) {
    return canPlay.file(url) && (document.pictureInPictureEnabled || supportsWebKitPresentationMode()) && !AUDIO_EXTENSIONS.test(url);
  },
  lazyPlayer: lazy(function () {
    return import(
    /* webpackChunkName: 'reactPlayerFilePlayer' */
    './FilePlayer');
  })
}];